/* I2C test program that writes & reads data to an I2C EEPROM device. */

#include <pic.h>
#include "delay.h"
#include "i2c.h"
#include "lcd.h"
#include <stdio.h>
#include <stdlib.h>



#define ROM 0xA0        /* I2C EEPROM */



void flashled(void) {           /* flash a led on RC0 */
	while(1) {
            RC0 = 1;
            DelayMs(200);
            RC0 = 0;
            DelayMs(200);
	}
}


void WriteByte(unsigned char addr, unsigned char byte) {
	i2c_WriteTo(ROM);
	if (i2c_PutByte(addr)==I2C_ERROR)
	lcd_puts("error write");
            //flashled();
	if (i2c_PutByte(byte)==I2C_ERROR)
        lcd_puts("error write");    
	    //flashled();
}

int ReadByte(unsigned char addr) {
	i2c_WriteTo(ROM);
	if (i2c_PutByte(addr)==I2C_ERROR)
	    lcd_puts("error read");
            //flashled();
        i2c_ReadFrom(ROM);
	return i2c_GetByte(I2C_LAST);
}


void main(void) 
{

 
  unsigned char platz1 = 0x11; 
  int val1;
  unsigned char ch1=0xA5;
  char a[15];
  TRISA = 0x00;
  TRISB = 0x00;
 
  lcd_init();		// LCD wird Initialisiert
  ADCON1 = 0b00000111;// Alle PINs an Port A sind digital
  lcd_clear();		// LCD wird gelscht
  lcd_puts("Test");


 /* initialize i2c */
 #ifdef I2C_MODULE
    SSPMode(MASTER_MODE);
    SSPEN = 1;
    CKP = 1;
 #else
    SCL_DIR = I2C_OUTPUT;
    SDA_DIR = I2C_OUTPUT;
    SDA = 0;
    SCL = 0;
 #endif




        WriteByte(platz1,ch1);           /* write to I2C EEPROM */
        val1 = ReadByte(platz1);            /* read back value */
        sprintf(a, "%d",val1); // Wandelt val1 in char a
        lcd_puts(a); // Gibt char a auf LCD aus
        DelayMs(200);


}


